SystemOrganization addCategory: #ConfigurationOfRoassal3d!

Object subclass: #ConfigurationOfRoassal3d
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRoassal3d'!

!ConfigurationOfRoassal3d class methodsFor: 'development support' stamp: 'AlexandreBergel 10/16/2013 12:50'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfRoassal3d class methodsFor: 'private' stamp: 'AlexandreBergel 10/16/2013 12:50'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfRoassal3d class methodsFor: 'private' stamp: 'AlexandreBergel 10/16/2013 12:50'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfRoassal3d class methodsFor: 'private' stamp: 'AlexandreBergel 10/16/2013 12:50'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfRoassal3d class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 10/16/2013 12:50'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRoassal3d class methodsFor: 'loading' stamp: 'AlexandreBergel 10/16/2013 12:50'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfRoassal3d class methodsFor: 'loading' stamp: 'AlexandreBergel 10/16/2013 12:50'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfRoassal3d class methodsFor: 'loading' stamp: 'AlexandreBergel 10/16/2013 12:50'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfRoassal3d class methodsFor: 'accessing' stamp: 'AlexandreBergel 10/16/2013 12:50'!
project

	^self new project! !

!ConfigurationOfRoassal3d class methodsFor: 'development support' stamp: 'AlexandreBergel 10/16/2013 12:50'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfRoassal3d methodsFor: 'baselines' stamp: 'AlexandreBergel 12/4/2013 18:07'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec project: 'ConfigurationOfNBOpenGL default' with: [
				spec
					className: 'ConfigurationOfNBOpenGL';
					version: '3.0';
					file:  'ConfigurationOfNBOpenGL';
					repository: 'http://www.smalltalkhub.com/mc/PharoExtras/NBOpenGL/main' ].

		spec project: 'ConfigurationOfRoassal default' with: [
				spec
					className: 'ConfigurationOfRoassal';
					version: '0.7-baseline';
					file:  'ConfigurationOfRoassal';
					repository: 'http://smalltalkhub.com/mc/ObjectProfile/Roassal/main' ].
		
		spec repository: 'http://smalltalkhub.com/mc/ronsaldo/roassal3d/main'.
		
		spec package: 'Roassal3d' with: [
			spec requires:  #('ConfigurationOfNBOpenGL default'  'ConfigurationOfRoassal default') ].  
		
		
		spec group: 'default' with: #('Roassal3d') ].
! !

!ConfigurationOfRoassal3d methodsFor: 'accessing' stamp: 'AlexandreBergel 10/16/2013 12:50'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfRoassal3d methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 10/16/2013 12:51'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfRoassal3d methodsFor: 'accessing' stamp: 'AlexandreBergel 10/16/2013 12:50'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfRoassal3d methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 12/4/2013 18:13'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1-baseline'.
! !
